#ifndef XINESTREAM_H
#define XINESTREAM_H 1

#include "jsreflect.h"
#include "Notifications.h"

#include <string>

class XineStatus;

class XineStream  : public JSReflection::Object, private Notifiable
{
    JS_EXPORTED_CLASS
public:
    typedef enum StreamStatus { StatusIdle, StatusPaused, StatusPlaying };
 
    Notifier playbackFinished;
protected:
    XineStatus * xine;
    
    virtual ~XineStream();
    
    std::string onStatusChanged;
    
    virtual void notified(Notifier * u);
public:
    XineStream();
    void dispose();
    
    bool open(const std::string & path);
    bool play();
    void pause();
    void resume();
    
    void stop();
    
    int getEqualizer() const;
    void setEqualizer(int i);
    
    int getVolume() const;
    void setVolume(int i);
    
    int getDuration();
    int getPosition();
    int getPlaying();
  
    std::string getStrStreamStatus();
    StreamStatus getStreamStatus();  
    std::string getOnStatusChanged() const;
    void setOnStatusChanged(const std::string & n);
};

#endif
