#include <SDL.h>
#include <SDL_image.h>

#include "Graphs.h"

#include <string>


Color Color::mix(const Color & a,const Color & b ,int cur,int max)
{
    Color rslt(
	a.r() +((b.r() - a.r()) * cur)/max,
	a.g() +((b.g() - a.g()) * cur)/max,
	a.b() +((b.b() - a.b()) * cur)/max,
	a.a() +((b.a() - a.a()) * cur)/max);
	
    return rslt;
}

Color::Color(int r,int g,int b,int a)
{
    color = ((r & 255) << 24) | ((g & 255) << 16) | ((b & 255) << 8) | (a & 255);
}

Uint32 Color::map(SDL_Surface *s) const
{
    return SDL_MapRGBA(s->format,r(),g(),b(),a());
}

void Color::setR(int r)
{
    r&=255;
    color = (color & 0xffffff) & (r << 24);
}

void Color::setG(int g)
{
    g&=255;
    color = (color & (~0xff0000)) & (g << 16);
}

void Color::setB(int b)
{
    b&=255;
    color = (color & (~0xff00)) & (b << 8);
}

void Color::setA(int a)
{
    a&=255;
    color = (color & (~0xff)) & a;
}

