#include "Application.h"
#include "JTimer.h"

JTimer::JTimer() :Timer(), JSReflection::Object(Application::getJsContext())  {
    autorepeat = false;
    disposed = false;
    lasttime = 0;
}

JTimer::~JTimer()
{
}

void JTimer::tick() {
    evaluate(js_code.c_str());
    if (disposed) {
        delete(this);
    } else {
        if (autorepeat) {
            lasttime += autorepeat_itv;
            setNextTick(lasttime);
        }
    }
}

void JTimer::singleStep(int ms)
{
    lasttime = Application::current->now() + ms;
    autorepeat = false;
    disposed = false;
    setNextTick(lasttime);
}

void JTimer::monotone(int ms)
{
    lasttime = Application::current->now() + ms;
    autorepeat_itv = ms;
    autorepeat = true;
    disposed = false;
    setNextTick(lasttime);
}

void JTimer::clear()
{
    autorepeat = false;
}

void JTimer::dispose()
{
    disposed = true;
}


JTimer * newTimer()  {
    return new JTimer();
}

void JTimer::setCode(const std::string & val)
{
    js_code = val;
}

std::string JTimer::getCode() const
{
    return js_code;
}


JS_EXPORT_CLASS(JTimer,JSReflection::Object)
JS_NOCONTEXT_GLOBAL_FUNCTION_0(newTimer,JTimer*,"%x",JTimer::ClassInfo)
JS_RW_PROPERTY(JTimer,code,getCode,setCode,JSReflection::JS_String,"%s",0);
JS_NOCONTEXT_OBJECT_VOID_FUNCTION_1(JTimer,monotone,int,"%i",0);
JS_NOCONTEXT_OBJECT_VOID_FUNCTION_1(JTimer,singleStep,int,"%i",0);
JS_NOCONTEXT_OBJECT_VOID_FUNCTION_0(JTimer,clear)
