#if 0

#include "Render.h"

#define max(a,b) ((a) > (b) ? (a) : (b))
#define min(a,b) ((a) < (b) ? (a) : (b))

void Renderer::layout() {
    floating.clear();
    currentLine.clear();
    currentLineTop = 0;
    currentLineX = 0;
    currentLineAscent = 0;
    currentLineDescent = 0;
    currentLineSkip = 0;
    
    for(typeof(items.begin()) it = items.begin(); it != items.end(); ++it) {
    	(*it)->updateSize();
    	addItemToLine(*it);
    }
}

void Renderer::findCollision(std::list<RendererItem*> & intersect,int x,int y,int w,int h) const {
    intersect.clear();
    for(typeof(floating.begin()) it = floating.begin(); it != floating.end(); ++it) {
	int vx1 = max(x,(*it)->x);
	int vy1 = max(y,(*it)->y);
	int vx2 = min(x + w - 1,(*it) ->x + (*it)->w - 1);
	int vy2 = min(y + h - 1,(*it) ->y + (*it)->h - 1);
	
	if (vx1 <= vx2 && vy1 <= vy2) {
	    intersect.push_back((*it));
	}
    }
}

void Renderer::terminateLine()
{
    // FIXME : adjust hpos of currentLine according to alignment...
    currentLine.clear();
    
    // FIXME : handle currentLineSkip = 0 properly !
    currentLineTop += currentLineSkip;
    
    currentLineX = 0;
    currentLineAscent = 0;
    currentLineDescent = 0;
    currentLineSkip = 0;
}

int Renderer::nextFreePlaceOnRight(int startx,int starty,int w,int h) const
{
    while(startx >= 0) {
	std::list<RendererItem*> intersect;
	findCollision(intersect,startx,starty,w,h);
	if (intersect.empty()) {
	    return startx;
	}
	for(typeof(intersect.begin()) it = intersect.begin(); it != intersect.end(); ++it) {
	    if (startx + w - 1 >= (*it)->x) {
		startx = (*it)->x - w;
	    }
	}
    }
    if (startx < 0) {
	return -1;
    }
    return startx;
}

int Renderer::nextFreePlaceOnRight(int startx,int starty,int w,int h) const
{
    while(startx + w <= areaWidth) {
	
	std::list<RendererItem*> intersect;
	findCollision(intersect,startx,starty,w,h);
	if (intersect.empty()) {
	    return startx;
	}
	
	for(typeof(intersect.begin()) it = intersect.begin(); it != intersect.end(); ++it) {
	    if (startx < ((*it)->x + (*it)->w)) {
		startx = ((*it)->x + (*it)->w);
	    }
	}
	
    }
    if (startx + w > areaWidth) {
	return -1;
    }
    return startx;
}

void Renderer::restartLine()
{
    std::list<RendererItem*> itemToAdd = currentLine;
    currentLine.clear();
    currentLineX = 0;
    currentLineAscent = 0;
    currentLineDescent = 0;
    currentLineSkip = 0;
    for(typeof(itemToAdd.begin()) it = itemToAdd.begin(); it != itemToAdd.end(); ++it) {
	addInline(*it);
    }
}

void Renderer::addFloating(RendererItem * git)
{
    int x,y;
    bool posok;
    RendererItem * ontheway;
    x = git->getPreferredLocation();
    y = currentLineTop;
    
    posok = false;
    do {
	std::list<RendererItem*> intersect;
	findCollision(intersect,x,y,git->w,git->h);
	/// go down until no more intersection
	if (!intersect.empty()) {
	    for(typeof(intersect.begin()) it = intersect.begin(); it != intersect.end(); ++it) {
		if (y < ((*it)->y + (*it)->h)) {
		    y = ((*it)->y + (*it)->h);
		}
	    }
	} else {
	    posok = true;
	}
    } while(!posok);
    
    git->x = x;
    git->y = y;
    
    if (!currentLine.empty()) {
	restartLine();
    }
}

void Renderer::addInline(RendererItem * git)
{
    
}
void Renderer::addItemToLine(RendererItem * git)
{
    if (git->floating()) {
	addFloating(git);
	
	/// Reprocess current line !
	restartCurrentLine();
	return;
    } else {
	int x;
	/// Search next x...
	do {
	    x = nextFreePlaceOnRight(
		    currentLineX,currentLineTop,
		    git->w,
		    max(currentLineAscent,git->ascent) + max(currentLineDescent,git->descent));
	    if (x == -1) {
		terminateLine();
	    }
	} while(x == -1);
	currentLineX = x;
	currentLineAscent = max(git->ascent,currentLineAscent);
	currentLineDescent = max(git->descent,currentLineDescent);
	currentLineSkip = max(git->lineskip - git->ascent, currentLineSkip);
	currentLine.push_back(git);
    }
}

#endif