#include "Style.h"
std::map<std::string,std::list<Style*> > Style::allStyles;

Style::Style()
{
}

Style::~Style()
{
}

void Style::add(const Style & s)
{
    for(typeof(s.values.begin()) it = s.values.begin(); it != s.values.end(); ++it) {
	values[it->first]  = it->second;
    }
}

void Style::applyTo(Widget * w)
{
    for(typeof(values.begin()) it = values.begin(); it != values.end(); ++it) {
	w->setProperty(it->first.c_str(),it->second.c_str());
    }
}

void Style::applyStyle(Widget * w)
{
    //cerr << "applying style to " << w->getStyle() <<endl;
    std::list<Style*> & styles = allStyles[w->getStyle()];

    for(typeof(styles.begin()) it = styles.begin(); it != styles.end(); ++it) {
	Style * cur = *it;
	bool ok = true;
	for(typeof(cur->filters.begin()) filter = cur->filters.begin(); filter != cur->filters.end(); ++filter) {
	    if (w->hasSubStyle(filter->first) != filter->second) {
		ok = false;
		break;
	    }
	}
	if (ok) {
	    cur->applyTo(w);
	}
    }
}

