#!/usr/bin/perl
use bytes;
use Fcntl ':mode';

my %extensions = (
  'jpg' => 'image',
  'avi' => 'video',
  'mp3' => 'sound' );

my %icons = (
  '' => 'icons/file.png',
  'special' => 'icons/special.png',
  'dir' => 'icons/folder.png',
  'img'	=> 'icons/image.png',
  'sound'=> 'icons/sound.png');
  
my %viewable = (
  'img' => '1');

#sub xmlec($) {
#  my $para = shift;
#  $para=~s/(\'|\"|\&|\#|\;)//g;
#  return "\"$para\"";
#}

sub xmlEncode($) {
    my $txt = shift;
    # FIXME : we assume we have unicode here
    my (@chars) = unpack("U0U*", $txt);
    $txt="";
    foreach $c(@chars) {
	if ($c != 0) {
	    $txt.=pack("U", $c);
	    # $txt .= " $c";
	} else {
	    $txt.="X";
	}
    }
    $txt=~s/&/&amp;/g;
    $txt=~s/(\'|\"|\#)/"&#".ord($1).";"/ge;
    return $txt;
}

sub binXmlEncode($) {
    my $txt = shift;
    $txt=~s/&/&amp;/g;
    $txt=~s/(\'|\"|\#|[^a-zA-Z0-9 -&\;])/"&#".ord($1).";"/ge;
    return $txt;
}

#
# list drectory content
# output is :
# <xml>
# <item display="" icon="" path="" viewable="0/1">
#
my $arg = $ARGV[0];

print STDERR "reading $arg\n";
opendir(DIRHANDLER,$arg);
@content = grep { /^[^\.]/ } readdir(DIRHANDLER);
close(DIRHANDLER);
print("<?xml version=\"1.0\" encoding=\"utf-8\"?>\n");
print("<xml>\n");

# print title
# print("<item desc="1" path='" . binXmlEncode($arg)."' display='".xmlEncode($arg)."'>\n");

foreach $file (sort @content) {
  my ($display,$path,$metaext,$icon,$view,$isdir,$channel,$date);
  
  $metaext = '';
  $path = $arg."/".$file;
  my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,
     $atime,$mtime,$ctime,$blksize,$blocks)
     = lstat($path);

  $display = $file;
  
  $isdir = 0;
  if (S_ISDIR($mode)) {
    $metaext = 'dir';
    $isdir = 1;
  } elsif (S_ISREG($mode)) {
    # Regular file
    if ($file=~m/(.*)\.(.+)$/) {
      my ($tmpdisplay,$tmpext) = ($1,lc($2));
      if (exists $extensions{$tmpext}) {
        $metaext = $extensions{$tmpext};
        $display = $tmpdisplay;
      }
    }
  } else {
    $metaext = 'special';
  }
  $icon = $icons{$metaext};
  if (exists($viewable{$metaext})) {
    $view = $viewable{$metaext};
  } else {
    $view = '0';
  }
  if ($file =~m/^(\d\d\d\d)\.(\d\d)\.(\d\d)-(\d\d).(\d\d)-(.*)-(.*).avi$/i) {
  	$display=$7;
  	$channel=$6;
  	$date="$3/$2/$1 $4:$5";
  } else {
  	$channel="";
  	$date="";
  }
  
  print("<item path='" . binXmlEncode($path) . "' icon='" . xmlEncode($icon) . "'" .
        " display='" . xmlEncode($display) . "' channel='" . xmlEncode($channel) . "'" .
        " date='" . xmlEncode($date) . "' viewable='" . xmlEncode($view) . "'" .
	" isdir='" . xmlEncode($isdir) . "' type='".xmlEncode($metaext)."' />\n"); 
}
print("</xml>\n");